/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import {z} from "zod";
import {TeamSchema} from "./team.js";
import {PlayerSchema} from "./data.js";

export const ShortEventSchema = z.object({
    id: z.number(),
    name: z.string(),
    start: z.number(),
    end: z.number(),
});

export type ShortEvent = z.infer<typeof ShortEventSchema>;

export const SWEventSchema = ShortEventSchema.extend({
    deadline: z.number(),
    maxTeamMembers: z.number(),
    schemType: z.string().nullable(),
    publicSchemsOnly: z.boolean(),
    referees: z.array(PlayerSchema),
});

export type SWEvent = z.infer<typeof SWEventSchema>;

export const EventFightSchema = z.object({
    id: z.number(),
    spielmodus: z.string(),
    map: z.string(),
    blueTeam: TeamSchema,
    redTeam: TeamSchema,
    start: z.number(),
    ergebnis: z.number(),
    spectatePort: z.number().nullable(),
    group: z.string().nullable(),
});

export type EventFight = z.infer<typeof EventFightSchema>;

export const ExtendedEventSchema = z.object({
    event: SWEventSchema,
    teams: z.array(TeamSchema),
    fights: z.array(EventFightSchema),
});

export type ExtendedEvent = z.infer<typeof ExtendedEventSchema>;
